/*
//	File:		CANTest.h
//	Created:	Christian Apfel
//	Date:		26.04.2017
//	Modified:	
//	Date:		
//
*/

#ifndef CANTEST_H
#define CANTEST_H

#include "DHHalLib.h"
#include <string>

static bool bEnabled;

typedef struct CANData {
    UINT32 DataLength;
	unsigned char *pData;
	UINT32 TXLoopDelay;
	UINT32 Result;
} CANDATA, *PCANDATA;

class CANTest
{
public:
	CANTest();
	~CANTest();
	void StartCanTest();
	bool CANWriteTest(DHCOM_CANModeEnum eCANMode, unsigned long lCANBitrate, int iCANID, unsigned char cCANPrio, int iCount, unsigned char *cData);
	bool CANReadTest(DHCOM_CANModeEnum eCANMode, unsigned long lCANBitrate, int *iCANID, int iCount, unsigned char *cData);
	bool CANRemoteWriteTest(DHCOM_CANModeEnum eCANMode, unsigned long lCANBitrate, int iCANID, unsigned char cCANPrio, int iCount, unsigned char *cData);
	bool CANRemoteReadTest(DHCOM_CANModeEnum eCANMode, unsigned long lCANBitrate, int *iCANID, int iCount, unsigned char *cData);
	bool CANFilterWriteTest(DHCOM_CANModeEnum eCANMode, unsigned long lCANBitrate, int iCANID, unsigned char cCANPrio, int iCANFilterID, int iCANFilterIDMask, int iCount, unsigned char *cData);
	bool CANFilterReadTest(DHCOM_CANModeEnum eCANMode, unsigned long lCANBitrate, int *iCANID, int iCANFilterID, int iCANFilterIDMask, int iCount, unsigned char *cData);
	bool AsyncronousReadWrite(DHCOM_CANModeEnum eCANMode, unsigned long lBitRate, int iID, bool bPRIO, int iDataLength, unsigned char *cData, unsigned long lTimeout, int iDelay);
};

DWORD WINAPI CAN_READ_THREAD( LPVOID lpParam );
DWORD WINAPI CAN_WRITE_THREAD( LPVOID lpParam );
void CanErrorHandler(LPTSTR lpszFunction);

#endif