/*
//	Description: Demo Control Functions
//	File:		ControlTest.cpp
//	Created:	Christian Apfel
//	Date:		15.12.2015
//
*/

#include "stdafx.h"
#include "ControlTest.h"

using namespace std;

ControlTest::ControlTest()
{

}

ControlTest::~ControlTest()
{

}

// ****** Demo App Menu Functions ******

void ControlTest::StartControlTest()
{
	int CONTROLTEST;
	char *cStatus = new char[20];

	// Wait Loop for 0 to Exit
	do
	{
		cout << "---------------------------------" << endl;
		cout << "Select Control Test!" << endl;
		cout << "---------------------------------" << endl;
		cout << "1: Reboot Device" << endl;
		cout << "2: Restart KITL" << endl;
		cout << "3: Control Power KITL" << endl;
		cout << "0: Main Menu" << endl;
		cout << "---------------------------------" << endl;
		cout << "Enter Test Number: ";
		cin >> CONTROLTEST;

		switch(CONTROLTEST)
		{
		case 1:
			{
				int keyToWaitFor = VK_RETURN;
				cout << endl;
				cout << "Reboot Device" << endl;
				cout << "------------------------------------" << endl;

				RebootDevice();
			}
			break;
		case 2:
			{
				int keyToWaitFor = VK_RETURN;
				cout << endl;
				cout << "Restart KITL Connection" << endl;
				cout << "------------------------------------" << endl;

				if(RestartKITL())
				{
					strcpy(cStatus, "Success");
				}
				else
				{
					strcpy(cStatus, "Failed");
				}

				cout << "Restart KITL is " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 3:
			{
				int iState;
				cout << endl;
				cout << "Restart KITL Connection" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter KITL Power Status: (0 = Off, 1 = On)";
				cin >> iState;

				if(iState == 0)
				{
					cout << "Attention!!! KITL Connection is Shutting down!!!" << endl;
				}

				if(ControlKITL(iState))
				{
					strcpy(cStatus, "Success");
				}
				else
				{
					strcpy(cStatus, "Failed");
				}

				cout << "Control KITL is " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 0:
			{
				delete(cStatus);
				return;
			}
		default:
			{
				cout << "Not valid Test Function!!!" << endl;
			}
			break;
		}
	}while(1);
}

// ****** Control Functions ******

bool ControlTest::RebootDevice()
{
	SoftReset();

	return true;
}

bool ControlTest::RestartKITL()
{
	if(!RestartPowerKITL())
	{
		return false;
	}
}

bool ControlTest::ControlKITL(int iState)
{
	bool bState = true;

	if(!iState)
	{
		bState = false;
	}

	if(!ControlPowerKITL(bState))
	{
		return false;
	}

	return true;
}