/*
//	Description: Demo GPIO Functions
//	File:		GPIO_Test.cpp
//	Created:	Christian Apfel
//	Date:		15.12.2015
//
*/

#include "stdafx.h"
#include "GPIOTest.h"
#include <iostream>

using namespace std;

HANDLE g_hThreads[THREADCOUNT];

GPIOTest gpioTest;

GPIOTest::GPIOTest()
{
	
}

GPIOTest::~GPIOTest()
{

}

// ****** Demo App Menu Functions ******

void GPIOTest::StartGpioTest()
{
	int GPIO_PIN_TEST;
	int GPIO_PIN_1;
	int GPIO_PIN_2;
	int GPIO_PIN_STATE;
	int GPIO_ISR_TYPE;
	char *cStatus = new char[20];
	int iLED = 0;
	int iButton = 0;

	// Wait Loop for 0 to Exit
	do
	{
		cout << "---------------------------------" << endl;
		cout << "Select Gpio Test!" << endl;
		cout << "---------------------------------" << endl;
		cout << "1: Loopback Test" << endl;
		cout << "2: LED Test" << endl;
		cout << "3: Set Pin Test" << endl;
		cout << "4: Get Pin Test" << endl;
		cout << "5: Button Interrupt Test" << endl;
		cout << "6: Button Single Interrupt Test" << endl;
		cout << "7: Button Polling Test" << endl;
		cout << "0: Main Menu" << endl;
		cout << "---------------------------------" << endl;
		cout << "Enter Test Number: ";
		cin >> GPIO_PIN_TEST;

		switch(GPIO_PIN_TEST)
		{
		case 1:
			{
				cout << endl;
				cout << "Gpio Loopback Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter Gpio1 Pin (e.g. 1 = GPIO_A): ";
				cin >> GPIO_PIN_1;
				cout << "Enter Gpio2 Pin (e.g. 2 = GPIO_B): ";
				cin >> GPIO_PIN_2;

				if(GPIOLoopbackTest((DHCOM_GPIOEnum)GPIO_PIN_1, (DHCOM_GPIOEnum)GPIO_PIN_2) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "Loopback Test GPIO " << GPIO_PIN_1 << " to " << GPIO_PIN_2 << " is " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 2:
			{
				bool bState = false;
				cout << endl;
				cout << "Gpio LED Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter Gpio LED Pin (e.g. 1 = LED1): ";
				cin >> GPIO_PIN_1;
				cout << "Enter Gpio LED State (e.g. 1|0): ";
				cin >> GPIO_PIN_STATE;

				if(GPIO_PIN_STATE == 1)
				{
					bState = true;
				}

				if(GPIO_PIN_1 == 1)
				{
					iLED = 6;
				}
				else if(GPIO_PIN_1 == 2)
				{
					iLED = 5;
				}
				else if(GPIO_PIN_1 == 3)
				{
					iLED = 8;
				}
				else if(GPIO_PIN_1 == 4)
				{
					iLED = 9;
				}
				else
				{
					cout << "Enter valid LED Number (1 to 4)" << endl;
					break;
				}

				if(GPIOLEDTest((DHCOM_GPIOEnum)iLED, bState) == true)
				{
					Sleep(100);
					if(GPIOGetPinTEST((DHCOM_GPIOEnum)GPIO_PIN_1) == bState)
					{
						cStatus = "Success";
					}
					else
					{
						cStatus = "Failed";
					}
				}
				else
				{
					cStatus = "GPIO Pin Error";
				}

				cout << "GPIO " << iLED << " Test is" << cStatus << "!!!" << endl;
			}
			break;
		case 3:
			{
				bool bState = false;
				cout << endl;
				cout << "Gpio Set Pin State" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter Gpio Pin (e.g. 1 = GPIO_A): ";
				cin >> GPIO_PIN_1;
				cout << "Enter Gpio State (e.g. 1|0): ";
				cin >> GPIO_PIN_STATE;

				if(GPIO_PIN_STATE == 1)
				{
					bState = true;
				}

				GPIOSetPinTEST((DHCOM_GPIOEnum)GPIO_PIN_1, bState);

				cout << "GPIO Pin " << GPIO_PIN_1 << " is " << bState << "!!!" << endl;
			}
			break;
		case 4:
			{
				bool bState = false;
				cout << endl;
				cout << "Gpio Get Pin State" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter Gpio Pin (e.g. 1 = GPIO_A): ";
				cin >> GPIO_PIN_1;

				if(GPIOGetPinTEST((DHCOM_GPIOEnum)GPIO_PIN_1) != 0)
				{
					cStatus = "HIGH";
				}
				else
				{
					cStatus = "LOW";
				}

				cout << "GPIO Pin " << GPIO_PIN_1 << " is " << cStatus << "!!!" << endl;
			}
			break;
		case 5:
			{
				bool bState = false;
				int keyToWaitFor = VK_SPACE;
				cout << endl;
				cout << "GPIO Button Interrupt Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter Input Gpio Pin (e.g. 1 = GPIO_A): ";
				cin >> GPIO_PIN_1;
				cout << "Enter ISR Type (e.g. 0=Low, 1=High, 2=Rise, 3=Fall, 4=Both, 5=None): ";
				cin >> GPIO_ISR_TYPE;
				
				if(GPIO_ISR_TYPE == 1 || GPIO_ISR_TYPE == 2)
				{
					cout << "Please push selected button before press space to continious interrupt test!";
					while(GetAsyncKeyState(keyToWaitFor) == 0);
				}

				if(GPIO_PIN_1 == 1)
				{
					iLED = 6;
					iButton = 1;
				}
				else if(GPIO_PIN_1 == 2)
				{
					iLED = 5;
					iButton = 2;
				}
				else if(GPIO_PIN_1 == 3)
				{
					iLED = 8;
					iButton = 3;
				}
				else if(GPIO_PIN_1 == 4)
				{
					iLED = 9;
					iButton = 4;
				}
				else
				{
					cout << "Enter valid Button Number (1 to 4)" << endl;
					break;
				}

				if(GPIOInterruptTest((DHCOM_GPIOEnum)iButton, (DHCOM_GPIOEnum)iLED, (DHCOM_GPIOISRType)GPIO_ISR_TYPE) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				GPIODeInitLeds();

				cout << "GPIO Pin " << GPIO_PIN_1 << " is " << cStatus << "!!!" << endl;
			}
			break;
		case 6:
			{
				bool bState = false;
				int keyToWaitFor = VK_SPACE;
				cout << endl;
				cout << "GPIO Button Interrupt Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter Input Gpio Pin (e.g. 1 = GPIO_A): ";
				cin >> GPIO_PIN_1;
				cout << "Enter ISR Type (e.g. 0=Low, 1=High, 2=Rise, 3=Fall, 4=Both, 5=None): ";
				cin >> GPIO_ISR_TYPE;
				
				if(GPIO_ISR_TYPE == 1 || GPIO_ISR_TYPE == 2)
				{
					cout << "Please push selected button before press space to continious interrupt test!";
					while(GetAsyncKeyState(keyToWaitFor) == 0);
				}

				if(GPIO_PIN_1 == 1)
				{
					iLED = 6;
					iButton = 1;
				}
				else if(GPIO_PIN_1 == 2)
				{
					iLED = 5;
					iButton = 2;
				}
				else if(GPIO_PIN_1 == 3)
				{
					iLED = 8;
					iButton = 3;
				}
				else if(GPIO_PIN_1 == 4)
				{
					iLED = 9;
					iButton = 4;
				}
				else
				{
					cout << "Enter valid Button Number (1 to 4)" << endl;
					break;
				}

				if(GPIOSingleInterruptTest((DHCOM_GPIOEnum)iButton, (DHCOM_GPIOEnum)iLED, (DHCOM_GPIOISRType)GPIO_ISR_TYPE) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				GPIODeInitLeds();

				cout << "GPIO Pin " << GPIO_PIN_1 << " is " << cStatus << "!!!" << endl;
			}
			break;
		case 7:
			{
				bool bState = false;
				int keyToWaitFor = VK_SPACE;
				cout << endl;
				cout << "Gpio Button Polling Test" << endl;
				cout << "------------------------------------" << endl;

				gpioTest.GPIOInitLeds();
				gpioTest.GPIOInitButtons();

				do
				{
					if(GPIOGetPinTEST(DHCOM_GPIO_A) == true)
					{
						GPIOSetPinTEST(DHCOM_GPIO_E, true);
					}
					else
					{
						GPIOSetPinTEST(DHCOM_GPIO_E, false);
					}
					
					if(GPIOGetPinTEST(DHCOM_GPIO_B) == true)
					{
						GPIOSetPinTEST(DHCOM_GPIO_F, true);
					}
					else
					{
						GPIOSetPinTEST(DHCOM_GPIO_F, false);
					}

					if(GPIOGetPinTEST(DHCOM_GPIO_C) == true)
					{
						GPIOSetPinTEST(DHCOM_GPIO_H, true);
					}
					else
					{
						GPIOSetPinTEST(DHCOM_GPIO_H, false);
					}

					if(gpioTest.GPIOGetPinTEST(DHCOM_GPIO_D) == true)
					{
						GPIOSetPinTEST(DHCOM_GPIO_I, true);
					}
					else
					{
						GPIOSetPinTEST(DHCOM_GPIO_I, false);
					}

					if (GetAsyncKeyState(keyToWaitFor)!=0){
						break;
					}

					cout << "Press Space for Break Test" << endl;
					Sleep(200);
				}while(1);

				gpioTest.GPIODeInitLeds();
			}
			break;
		case 0:
			{
				return;
			}
		default:
			{
				cout << "Not valid Test Function!!!" << endl;
			}
			break;
		}
	}while(1); //GPIO_PIN_TEST != 0);
}

// ****** GPIO Functions ******

bool GPIOTest::GPIOLoopbackTest(DHCOM_GPIOEnum out_eGPIO, DHCOM_GPIOEnum in_eGPIO)
{
	GPIOSetDirection(out_eGPIO, false, false);
	GPIOSetDirection(in_eGPIO, true, false);

	GPIOSetPin(out_eGPIO, true);

	if(GPIOGetPin(in_eGPIO) == true)
	{
		return true;
	}

	return false;
}

bool GPIOTest::GPIOInterruptTest(DHCOM_GPIOEnum in_eGPIO, DHCOM_GPIOEnum out_eGPIO, DHCOM_GPIOISRType inGPIOISRType)
{
	char *cStatus = new char[10];
	bool bState = false;
	char cAbortFor = 'q';
	int keyToWaitFor = VK_SPACE;
	int keyToAbortFor = VK_ESCAPE;

	//CreateEventAndThread();

	g_hEvent = CreateEvent( NULL, TRUE, FALSE, TEXT("GPIOLEDTest"));

    if (g_hEvent == NULL)
    { 
        printf("CreateEvent failed (%d)\n", GetLastError());
        return false;
    }
	
	GPIOSetDirection(in_eGPIO, true, false);
	GPIOSetDirection(out_eGPIO, false, false);

	do
	{   
		GPIOSetPin(out_eGPIO, false);

		if(GPIOSetInterrupt(in_eGPIO, inGPIOISRType, &g_hEvent, 20000) == true)
		{
			GPIOSetPin(out_eGPIO, true);

			ResetEvent(g_hEvent);

			if(MessageBox(NULL, L"Interrupt Event Detected, Continue?", L"Interrupt Detect", MB_YESNO|MB_TOPMOST) == IDNO)
			{
				cStatus = "Success";
				break;
			}
		}
		else
		{
			cStatus = "Failed";
			break;
		}
	}while(1);

	GPIOClearInterrupt(in_eGPIO);

	CloseHandle(g_hEvent);
	
	if(g_hEvent != INVALID_HANDLE_VALUE)
    {
		cStatus = "Success";
    }
	else
	{
		cStatus = "Failed";
	}

	cout << "Interrupttest on Button TA" << (int)in_eGPIO << " is " << cStatus << "!!!" << endl;

	//delete(cStatus);

	return true;
}

bool GPIOTest::GPIOSingleInterruptTest(DHCOM_GPIOEnum in_eGPIO, DHCOM_GPIOEnum out_eGPIO, DHCOM_GPIOISRType inGPIOISRType)
{
	char *cStatus = new char[10];
	bool bState = false;

	//CreateEventAndThread();

	g_hEvent = CreateEvent( NULL, TRUE, FALSE, TEXT("GPIOLEDTest"));

    if (g_hEvent == NULL)
    { 
        printf("CreateEvent failed (%d)\n", GetLastError());
        return false;
    }
	
	GPIOSetDirection(in_eGPIO, true, false);
	GPIOSetDirection(out_eGPIO, false, false);
 
	GPIOSetPin(out_eGPIO, false);

	if(GPIOSetSingleInterrupt(in_eGPIO, inGPIOISRType, 20000) == true)
	{
		GPIOSetPin(out_eGPIO, true);
		cStatus = "Success";

		MessageBox(NULL, L"Interrupt Event Detected!", L"Interrupt Detect", MB_OK|MB_TOPMOST);
	}
	else
	{
		cStatus = "Failed";
	}

	GPIOClearInterrupt(in_eGPIO);

	cout << "Single Interrupttest on Button TA" << (int)in_eGPIO << " is " << cStatus << "!!!" << endl;

	return true;
}

bool GPIOTest::GPIOLEDTest(DHCOM_GPIOEnum eGPIO, bool bState)
{
	GPIOSetDirection(eGPIO, false, false);

	GPIOSetPin(eGPIO, bState);

	return true;
}

bool GPIOTest::GPIOSetPinTEST(DHCOM_GPIOEnum eGPIO, bool bState)
{
	GPIOSetDirection(eGPIO, false, false);

	GPIOSetPin(eGPIO, bState);

	return true;
}

bool GPIOTest::GPIOGetPinTEST(DHCOM_GPIOEnum eGPIO)
{
	//GPIOSetDirection(eGPIO, true, false);

	if(GPIOGetPin(eGPIO) == true)
	{
		cout << "Pin is High" << endl;
		return true;
	}
	else
	{
		cout << "Pin is Low" << endl;
	}

	return false;
}

void GPIOTest::GPIOInitLeds()
{
	GPIOSetDirection(DHCOM_GPIO_E, false, false);
	GPIOSetDirection(DHCOM_GPIO_F, false, false);
	GPIOSetDirection(DHCOM_GPIO_H, false, false);
	GPIOSetDirection(DHCOM_GPIO_I, false, false);
}

void GPIOTest::GPIODeInitLeds()
{
	GPIOSetDirection(DHCOM_GPIO_E, false, true);
	GPIOSetDirection(DHCOM_GPIO_F, false, true);
	GPIOSetDirection(DHCOM_GPIO_H, false, true);
	GPIOSetDirection(DHCOM_GPIO_I, false, true);
}

void GPIOTest::GPIOInitButtons()
{
	GPIOSetDirection(DHCOM_GPIO_A, true, false);
	GPIOSetDirection(DHCOM_GPIO_B, true, false);
	GPIOSetDirection(DHCOM_GPIO_C, true, false);
	GPIOSetDirection(DHCOM_GPIO_D, true, false);
}

void GPIOTest::GPIOSetLED()
{
	//GPIOSetDirection(DHCOM_GPIO_I, false, false);

	if(GPIOGetPin(DHCOM_GPIO_I) == true)
	{
		GPIOSetPin(DHCOM_GPIO_I, false);
	}
	else
	{
		GPIOSetPin(DHCOM_GPIO_I, true);
	}
}

void GPIOTest::CreateEventAndThread(void)
{
	//int i;
    DWORD dwThreadID;

    g_hEvent = CreateEvent( 
        NULL,               // default security attributes
        TRUE,               // manual-reset event
        FALSE,              // initial state is nonsignaled
		TEXT("GPIOSetLED")  // object name
        ); 

    if (g_hEvent == NULL) 
    { 
        printf("CreateEvent failed (%d)\n", GetLastError());
        return;
    }

    // Create thread to read from the GPIO Pin.

	g_hThreads[0] = CreateThread(
		NULL,              // default security
		0,                 // default stack size
		ThreadProc,        // name of the thread function
		NULL,              // no thread parameters
		0,                 // default startup flags
		&dwThreadID);

	//for(i = 0; i < THREADCOUNT; i++)
	//{
	//	g_hThreads[i] = CreateThread(
	//		NULL,              // default security
	//		0,                 // default stack size
	//		ThreadProc,        // name of the thread function
	//		NULL,              // no thread parameters
	//		0,                 // default startup flags
	//		&dwThreadID); 

	//	if (g_hThreads[i] == NULL)
	//	{
	//		printf("CreateThread failed (%d)\n", GetLastError());
	//		return;
	//	}
	//}
}

DWORD WINAPI ThreadProc(LPVOID lpParam)
{
	BOOL bStatus;
	
	GPIOSetDirection(DHCOM_GPIO_E, false, false);
	
	if(GPIOSetInterrupt(DHCOM_GPIO_A, DHCOM_GPIO_INTR_BOTH_EDGE, &g_hEvent, 20000) == true)
	{
		GPIOSetPin(DHCOM_GPIO_E, true);
		bStatus = 0;
	}

	return (DWORD)bStatus;
}

//void GPIOTest::SetThreadEvent()
//{
//	if (!SetEvent(p_hGpioEvent))
//    {
//        printf("SetEvent failed (%d)\n", GetLastError());
//        return;
//    }
//}
//
//DWORD WINAPI ThreadProc(LPVOID lpParam)
//{
//    // lpParam not used in this example.
//    UNREFERENCED_PARAMETER(lpParam);
//
//    DWORD dwWaitResult;
//
//    printf("Thread %d waiting for GPIO event...\n", GetCurrentThreadId());
//    
//	dwWaitResult = WaitForSingleObject(gpioTest.p_hGpioEvent, 30000);
//
//    switch (dwWaitResult) 
//    {
//	// Event object was signaled
//	case WAIT_OBJECT_0:
//		{
//			printf("Thread %d waiting from Gpio\n", GetCurrentThreadId());
//		}
//		break;
//	// An error occurred
//	default: 
//		{
//			printf("Wait error (%d)\n", GetLastError()); 
//			return 0;
//		}
//    }
//
//    printf("Thread %d exiting\n", GetCurrentThreadId());
//    return 1;
//}
