/*
//	Description: Demo CAN Functions
//	File:		UARTTest.cpp
//	Created:	Christian Apfel
//	Date:		24.04.2016
//
*/

#include "stdafx.h"
#include "UARTTest.h"

using namespace std;

UARTTest::UARTTest()
{

}

UARTTest::~UARTTest()
{

}

// ****** Demo App Menu Functions ******

void UARTTest::StartUartTest()
{
	int UART_TEST;
	int UART_DEV;
	int UART_DEV_MODE;
	int UART_DEV_PARITY;
	int UART_DEV_STOPBITS;
	int UART_DEV_BYTESIZE;
	int UART_COUNT;
	long UART_FREQ;
	unsigned char UART_SEND_DATA[100];
	unsigned char UART_RECEIVE_DATA[100];
	char *cStatus = new char[20];

	// Wait Loop for 0 to Exit
	do
	{
		cout << "---------------------------------" << endl;
		cout << "Select UART Test!" << endl;
		cout << "---------------------------------" << endl;
		cout << "1: Write Test" << endl;
		cout << "2: Read Test" << endl;
		cout << "0: Main Menu" << endl;
		cout << "---------------------------------" << endl;
		cout << "Enter Test Number: ";
		cin >> UART_TEST;

		switch(UART_TEST)
		{
		case 1:
			{
				cout << endl;
				cout << "UART Write Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter UART Device (1,2,3): ";
				cin >> UART_DEV;
				cout << "Enter UART Mode (Flowcontrol: 0 = Off, 1 = Software, 2 = Hardware): ";
				cin >> UART_DEV_MODE;
				cout << "Enter UART Parity Mode (Parity: 0 = NO, 1 = ODD, 2 = EVEN, 3 = MARK, 4 = SPACE): ";
				cin >> UART_DEV_PARITY;
				cout << "Enter UART Stopbits Mode (Parity: 0 = ONE, 1 = ONE5STOPBITS, 2 = TWOSTOPBITS): ";
				cin >> UART_DEV_STOPBITS;
				cout << "Enter UART Byte size (Bytesize: 5 = DHCOM_5BIT, 6 = DHCOM_6BIT, 7 = DHCOM_7BIT, 8 = DHCOM_8BIT): ";
				cin >> UART_DEV_BYTESIZE;
				cout << "Enter UART Frequency (1200 ... 256000 Hz): ";
				cin >> UART_FREQ;
				cout << "Enter UART Data (e.g. abc): ";
				cin >> UART_SEND_DATA;

				if(UARTWriteTest(DHCOM_UARTEnum(UART_DEV), DHCOM_UARTModeEnum(UART_DEV_MODE), DHCOM_UARTParityEnum(UART_DEV_PARITY), DHCOM_UARTStopBitEnum(UART_DEV_STOPBITS), DHCOM_UARTByteSizeEnum(UART_DEV_BYTESIZE), UART_FREQ, UART_SEND_DATA) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "UART Write Test - Data: " << UART_SEND_DATA << " Status: " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 2:
			{
				cout << endl;
				cout << "UART Read Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter UART Device (1,2,3): ";
				cin >> UART_DEV;
				cout << "Enter UART Mode (Flowcontrol: 0 = Off, 1 = Software, 2 = Hardware): ";
				cin >> UART_DEV_MODE;
				cout << "Enter UART Parity Mode (Parity: 0 = NO, 1 = ODD, 2 = EVEN, 3 = MARK, 4 = SPACE): ";
				cin >> UART_DEV_PARITY;
				cout << "Enter UART Stopbits Mode (Parity: 0 = ONE, 1 = ONE5STOPBITS, 2 = TWOSTOPBITS): ";
				cin >> UART_DEV_STOPBITS;
				cout << "Enter UART Byte size (Bytesize: 5 = DHCOM_5BIT, 6 = DHCOM_6BIT, 7 = DHCOM_7BIT, 8 = DHCOM_8BIT): ";
				cin >> UART_DEV_BYTESIZE;
				cout << "Enter UART Frequency (1200 ... 256000 Hz): ";
				cin >> UART_FREQ;
				cout << "Enter UART Character Count (1 ... 100): ";
				cin >> UART_COUNT;

				if(UARTReadTest(DHCOM_UARTEnum(UART_DEV), DHCOM_UARTModeEnum(UART_DEV_MODE), DHCOM_UARTParityEnum(UART_DEV_PARITY), DHCOM_UARTStopBitEnum(UART_DEV_STOPBITS), DHCOM_UARTByteSizeEnum(UART_DEV_BYTESIZE), UART_FREQ, UART_COUNT, UART_RECEIVE_DATA) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "UART Read Test - Data: " << UART_RECEIVE_DATA << " Status: " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 0:
			{
				return;
			}
			break;
		default:
			{

			}
			break;
		}
	}while(1);
}

// ****** UART Functions ******

bool UARTTest::UARTWriteTest(DHCOM_UARTEnum eUARTPort, DHCOM_UARTModeEnum eUARTMode, DHCOM_UARTParityEnum eParity, DHCOM_UARTStopBitEnum eStopbits, DHCOM_UARTByteSizeEnum eBytesize, long lUARTBaudrate, unsigned char *cData)
{
	if(UARTOpen(eUARTPort, eUARTMode, lUARTBaudrate) == true)
	{
		if(UARTConfigure(eUARTPort, eUARTMode, eParity, eStopbits, eBytesize, lUARTBaudrate) == false)
		{
			UARTClose(eUARTPort);
			return false;
		}

		if(UARTWrite(eUARTPort, cData) == true)
		{
			UARTClose(eUARTPort);
			return true;
		}

		UARTClose(eUARTPort);
	}

	return false;
}

bool UARTTest::UARTReadTest(DHCOM_UARTEnum eUARTPort, DHCOM_UARTModeEnum eUARTMode, DHCOM_UARTParityEnum eParity, DHCOM_UARTStopBitEnum eStopbits, DHCOM_UARTByteSizeEnum eBytesize, long lUARTBaudrate, int iCount, unsigned char *cData)
{
	if(UARTOpen(eUARTPort, eUARTMode, lUARTBaudrate) == true)
	{
		if(UARTConfigure(eUARTPort, eUARTMode, eParity, eStopbits, eBytesize, lUARTBaudrate) == false)
		{
			UARTClose(eUARTPort);
			return false;
		}

		/*if(eUARTMode == 0)
		{
			cout << "UART Wait for Input (5 sec)";
			Sleep(5000);
		}*/

		if(UARTRead(eUARTPort, iCount, cData) == true)
		{
			UARTClose(eUARTPort);
			return true;
		}

		UARTClose(eUARTPort);
	}

	cout << "UART Read Test failed";

	return false;
}